<template>
  <div class="text-center">
    <h3 class="text-primary">Registration Form</h3>
  </div>

  <GuestInfoComponent
    :student-data="guestData"
    :existing-guest="existingGuest"
  />

  <div class="container">
    <div class="row mt-4 mb-3">
      <div class="col-5 mx-auto">
        <button
          class="w-100 btn btn-primary btn-lg"
          type="button"
          @click="submitGuestData"
        >
          Register
        </button>
      </div>

      <div class="col-5 mx-auto">
        <button
          class="w-100 btn btn-danger btn-lg"
          type="button"
          @click="cancel"
        >
          Cancel
        </button>
      </div>
    </div>
  </div>
</template>
    
<script>
import { databaseWarehouse } from '../stores/wsuStudentStore'

import GuestInfoComponent from '../components/GuestInfoComponent.vue'

export default {
  components: {
    GuestInfoComponent
  },
	data() {
		return {
			guestData: {
        wsuID: databaseWarehouse().guestData.wsuID,
        resident: true,
        zipCode: "",
        unemployment: false,
        assistance: {
            socSec: false,
            TANF: false,
            finAid: false,
            other: false,
            SNAP: false,
            WIC: false,
            breakfast: false,
            lunch: false,
            SFSP: false
        },
        guestAge: 0,
        numberInHousehold: 1,
        },
        existingGuest: false
		}
	},
  async mounted() {
    // scroll to the top of the component when page is loaded
			window.scrollTo(0,0)
  },
	
	methods: {
		async fetchGuestData() {
			try {
				let guestURL = "http://localhost:10350/guests/" + this.idNum
				let response = await fetch(guestURL)

				if (response.status == 200) {
          this.guestData = response.data
          this.existingGuest = true
          console.log(this.guestData)
				} 
			} catch (err) {
					if (err.response.status == 404) {
						console.log("not found")
						this.guestData.wsuID = this.idNum
						this.existingGuest = false
						alert("Guest with ID " + this.idNum + " not found.\nTo add guest, complete the form and click Submit Changes.\nOtherwise click Cancel.")
					}
					console.log(err)
			}
		},
		// Send Guest Information to Backend 
		async submitGuestData() {
      // Do form validation before submit. I'm skipping this due to time constraints
      await databaseWarehouse().createGuest(this.guestData) 
    },
    cancel() {
      // Send back to login page
      this.$router.push('/')
    }
	}
}

</script> 

<!-- Add 'scoped' attribute to limit CSS to this component only -->
<style>

</style>
